Index: contrib/asdf/asdf.texinfo
===================================================================
RCS file: /cvsroot/sbcl/sbcl/contrib/asdf/asdf.texinfo,v
retrieving revision 1.2
diff -u -r1.2 asdf.texinfo
--- contrib/asdf/asdf.texinfo	18 Aug 2004 12:58:41 -0000	1.2
+++ contrib/asdf/asdf.texinfo	21 Jun 2010 23:08:56 -0000
@@ -602,54 +1245,62 @@
 @cindex system designator
 @vindex *system-definition-search-functions*
 
-A @dfn{component} represents a source file or (recursively) a
-collection of components.  A @dfn{system} is (roughly speaking) a
-top-level component that can be found via @code{find-system}.
-
-A @dfn{system designator} is a string or symbol and behaves just like
-any other component name (including with regard to the case conversion
-rules for component names).
+A @dfn{component} represents a source file or
+(recursively) a collection of components.
+A @dfn{system} is (roughly speaking) a top-level component
+that can be found via @code{find-system}.
+
+A @dfn{system designator} is a string or symbol
+and behaves just like any other component name
+(including with regard to the case conversion rules for component names).
 
 
 @defun find-system system-designator &optional (error-p t)
 
-Given a system designator, @code{find-system} finds and returns a
-system.  If no system is found, an error of type
-@code{missing-component} is thrown, or @code{nil} is returned if
-@code{error-p} is false.
+Given a system designator, @code{find-system} finds and returns a system.
+If no system is found, an error of type
+@code{missing-component} is thrown,
+or @code{nil} is returned if @code{error-p} is false.
 
 To find and update systems, @code{find-system} funcalls each element
-in the @code{*system-definition-search-functions*} list, expecting a
-pathname to be returned.  The resulting pathname is loaded if either
-of the following conditions is true:
+in the @code{*system-definition-search-functions*} list,
+expecting a pathname to be returned.
+The resulting pathname is loaded if either of the following conditions is true:
 
 @itemize
-@item there is no system of that name in memory
-@item the file's last-modified time exceeds the last-modified time of the
-  system in memory
+@item
+there is no system of that name in memory
+@item
+the file's @code{last-modified} time exceeds the @code{last-modified} time
+of the system in memory
 @end itemize
 
-When system definitions are loaded from @file{.asd} files, a new
-scratch package is created for them to load into, so that different
-systems do not overwrite each others operations.  The user may also
-wish to (and is recommended to) include @code{defpackage} and
-@code{in-package} forms in his system definition files, however, so
-that they can be loaded manually if need be.
-
-The default value of @code{*system-definition-search-functions*} is a
-function that looks in each of the directories given by evaluating
-members of @code{*central-registry*} for a file whose name is the
-name of the system and whose type is @file{asd}.  The first such file
-is returned, whether or not it turns out to actually define the
-appropriate system.  Hence, it is strongly advised to define a system
+When system definitions are loaded from @file{.asd} files,
+a new scratch package is created for them to load into,
+so that different systems do not overwrite each others operations.
+The user may also wish to (and is recommended to)
+include @code{defpackage} and @code{in-package} forms
+in his system definition files, however,
+so that they can be loaded manually if need be.
+
+The default value of @code{*system-definition-search-functions*}
+is a list of two functions.
+The first function looks in each of the directories given
+by evaluating members of @code{*central-registry*}
+for a file whose name is the name of the system and whose type is @file{asd}.
+The first such file is returned,
+whether or not it turns out to actually define the appropriate system.
+The second function does something similar,
+for the directories specified in the @code{source-registry}.
+Hence, it is strongly advised to define a system
 @var{foo} in the corresponding file @var{foo.asd}.
 @end defun
 
 
 @menu
-* Common attributes of components::  
-* Pre-defined subclasses of component::  
-* Creating new component types::  
+* Common attributes of components::
+* Pre-defined subclasses of component::
+* Creating new component types::
 @end menu
 
 @node  Common attributes of components, Pre-defined subclasses of component, Components, Components
@@ -661,55 +1312,68 @@
 
 @subsubsection Name
 
-A component name is a string or a symbol.  If a symbol, its name is
-taken and lowercased.  The name must be a suitable value for the
-@code{:name} initarg to @code{make-pathname} in whatever filesystem
-the system is to be found.
-
-The lower-casing-symbols behaviour is unconventional, but was selected
-after some consideration.  Observations suggest that the type of
-systems we want to support either have lowercase as customary case
-(Unix, Mac, windows) or silently convert lowercase to uppercase
-(lpns), so this makes more sense than attempting to use @code{:case
-:common} as argument to @code{make-pathname}, which is reported not to
-work on some implementations
+A component name is a string or a symbol.
+If a symbol, its name is taken and lowercased.
+
+Unless overridden by a @code{:pathname} attribute,
+the name will be interpreted as a pathname specifier according
+to a Unix-style syntax.
+@xref{The defsystem grammar,,Pathname specifiers}.
 
 @subsubsection Version identifier
 
-This optional attribute is used by the test-system-version
-operation. @xref{Predefined operations of asdf}.  For the default method of
-test-system-version, the version should be a string of intergers
-separated by dots, for example @samp{1.0.11}.
+This optional attribute is used by the @code{test-system-version} operation.
+@xref{Predefined operations of ASDF}.
+For the default method of @code{test-system-version},
+the version should be a string of integers separated by dots,
+for example @samp{1.0.11}.
+
+@emph{Nota Bene}:
+This operation, planned for ASDF 1,
+is still not implement yet as of ASDF 2.
+Don't hold your breath.
+
 
 @subsubsection Required features
 
-Traditionally defsystem users have used reader conditionals to include
-or exclude specific per-implementation files.  This means that any
-single implementation cannot read the entire system, which becomes a
-problem if it doesn't wish to compile it, but instead for example to
-create an archive file containing all the sources, as it will omit to
-process the system-dependent sources for other systems.
+@emph{FIXME: This subsection seems to contradict the
+@code{defsystem} grammar subsection,
+which doesn't provide any obvious way to specify required features.
+Furthermore, in 2009, discussions on the
+@url{http://common-lisp.net/cgi-bin/mailman/listinfo/asdf-devel,asdf-devel mailing list}
+suggested that the specification of required features may be broken,
+and that no one may have been using them for a while.
+Please contact the
+@url{http://common-lisp.net/cgi-bin/mailman/listinfo/asdf-devel,asdf-devel mailing list}
+if you are interested in getting this features feature fixed.}
+
+Traditionally defsystem users have used reader conditionals
+to include or exclude specific per-implementation files.
+This means that any single implementation cannot read the entire system,
+which becomes a problem if it doesn't wish to compile it,
+but instead for example to create an archive file containing all the sources,
+as it will omit to process the system-dependent sources for other systems.
 
 Each component in an asdf system may therefore specify features using
-the same syntax as #+ does, and it will (somehow) be ignored for
+the same syntax as @code{#+} does, and it will (somehow) be ignored for
 certain operations unless the feature conditional is a member of
 @code{*features*}.
 
 
 @subsubsection Dependencies
 
-This attribute specifies dependencies of the component on its
-siblings.  It is optional but often necessary.
+This attribute specifies dependencies of the component on its siblings.
+It is optional but often necessary.
 
 There is an excitingly complicated relationship between the initarg
 and the method that you use to ask about dependencies
 
-Dependencies are between (operation component) pairs.  In your
-initargs for the component, you can say
+Dependencies are between (operation component) pairs.
+In your initargs for the component, you can say
 
 @lisp
 :in-order-to ((compile-op (load-op "a" "b") (compile-op "c"))
-	      (load-op (load-op "foo")))
+              (load-op (load-op "foo")))
 @end lisp
 
 This means the following things:
@@ -735,8 +1399,8 @@
 
 Side note:
 
-This is on a par with what ACL defsystem does.  mk-defsystem is less
-general: it has an implied dependency
+This is on a par with what ACL defsystem does.
+mk-defsystem is less general: it has an implied dependency
 
 @verbatim
   for all x, (load x) depends on (compile x)
@@ -746,7 +1410,7 @@
 @var{a} @emph{actually} means that
 
 @verbatim
-  (compile b) depends on (load a) 
+  (compile b) depends on (load a)
 @end verbatim
 
 This is insufficient for e.g. the McCLIM system, which requires that
@@ -754,81 +1418,69 @@
 
 End side note
 
-In asdf, the dependency information for a given component and
-operation can be queried using @code{(component-depends-on operation
-component)}, which returns a list
+In ASDF, the dependency information for a given component and operation
+can be queried using @code{(component-depends-on operation component)},
+which returns a list
 
 @lisp
 ((load-op "a") (load-op "b") (compile-op "c") ...)
 @end lisp
 
 @code{component-depends-on} can be subclassed for more specific
-component/operation types: these need to @code{(call-next-method)} and
-append the answer to their dependency, unless they have a good reason
-for completely overriding the default dependencies
-
-(If it weren't for CLISP, we'd be using a @code{LIST} method
-combination to do this transparently.  But, we need to support CLISP.
-If you have the time for some CLISP hacking, I'm sure they'd welcome
-your fixes)
+component/operation types: these need to @code{(call-next-method)}
+and append the answer to their dependency, unless
+they have a good reason for completely overriding the default dependencies.
+
+If it weren't for CLISP, we'd be using @code{LIST} method
+combination to do this transparently.
+But, we need to support CLISP.
+If you have the time for some CLISP hacking,
+I'm sure they'd welcome your fixes.
+@c Doesn't CLISP now support LIST method combination?
 
 @subsubsection pathname
 
-This attribute is optional and if absent will be inferred from the
-component's name, type (the subclass of source-file), and the location
-of its parent.
-
-The rules for this inference are:
-
-(for source-files)
-@itemize
-@item the host is taken from the parent
-@item pathname type is @code{(source-file-type component system)}
-@item the pathname case option is @code{:local}
-@item the pathname is merged against the parent
-@end itemize
-
-(for modules)
-@itemize
-@item the host is taken from the parent
-@item the name and type are @code{NIL}
-@item the directory is @code{(:relative component-name)}
-@item the pathname case option is @code{:local}
-@item the pathname is merged against the parent
-@end itemize
+This attribute is optional and if absent (which is the usual case),
+the component name will be used.
 
-Note that the DEFSYSTEM operator (used to create a ``top-level''
-system) does additional processing to set the filesystem location of
-the top component in that system.  This is detailed
-elsewhere, @xref{Defining systems with defsystem}.
+@xref{The defsystem grammar,,Pathname specifiers},
+for an explanation of how this attribute is interpreted.
 
-The answer to the frequently asked question "how do I create a system 
-definition where all the source files have a .cl extension" is thus
+Note that the @code{defsystem} macro (used to create a ``top-level'' system)
+does additional processing to set the filesystem location of
+the top component in that system.
+This is detailed elsewhere. @xref{Defining systems with defsystem}.
+
+The answer to the frequently asked question
+``how do I create a system definition
+where all the source files have a @file{.cl} extension''
+is thus
 
 @lisp
 (defmethod source-file-type ((c cl-source-file) (s (eql (find-system 'my-sys))))
-   "cl")
+  "cl")
 @end lisp
 
 @subsubsection properties
 
 This attribute is optional.
 
-Packaging systems often require information about files or systems in
-addition to that specified by asdf's pre-defined component attributes.
-Programs that create vendor packages out of asdf systems therefore
+Packaging systems often require information about files or systems
+in addition to that specified by ASDF's pre-defined component attributes.
+Programs that create vendor packages out of ASDF systems therefore
 have to create ``placeholder'' information to satisfy these systems.
-Sometimes the creator of an asdf system may know the additional
+Sometimes the creator of an ASDF system may know the additional
 information and wish to provide it directly.
 
-(component-property component property-name) and associated setf
-method will allow the programmatic update of this information.
-Property names are compared as if by @code{EQL}, so use symbols or
-keywords or something.
+@code{(component-property component property-name)} and
+associated @code{setf} method will allow
+the programmatic update of this information.
+Property names are compared as if by @code{EQL},
+so use symbols or keywords or something.
 
 @menu
-* Pre-defined subclasses of component::  
-* Creating new component types::  
+* Pre-defined subclasses of component::
+* Creating new component types::
 @end menu
 
 @node Pre-defined subclasses of component, Creating new component types, Common attributes of components, Components
@@ -838,18 +1490,20 @@
 @deffn Component source-file
 
 A source file is any file that the system does not know how to
-generate from other components of the system. 
+generate from other components of the system.
 
-Note that this is not necessarily the same thing as ``a file
-containing data that is typically fed to a compiler''.  If a file is
-generated by some pre-processor stage (e.g. a @file{.h} file from
-@file{.h.in} by autoconf) then it is not, by this definition, a source
-file.  Conversely, we might have a graphic file that cannot be
-automatically regenerated, or a proprietary shared library that we
-received as a binary: these do count as source files for our purposes.
+Note that this is not necessarily the same thing as
+``a file containing data that is typically fed to a compiler''.
+If a file is generated by some pre-processor stage
+(e.g. a @file{.h} file from @file{.h.in} by autoconf)
+then it is not, by this definition, a source file.
+Conversely, we might have a graphic file
+that cannot be automatically regenerated,
+or a proprietary shared library that we received as a binary:
+these do count as source files for our purposes.
 
-Subclasses of source-file exist for various languages.  @emph{FIXME:
-describe these.}
+Subclasses of source-file exist for various languages.
+@emph{FIXME: describe these.}
 @end deffn
 
 @deffn Component module
@@ -863,27 +1517,32 @@
 @code{:components} the components contained in this module
 
 @item
-@code{:default-component-class} All child components which don't
-specify their class explicitly are inferred to be of this type.
+@code{:default-component-class}
+All children components which don't specify their class explicitly
+are inferred to be of this type.
 
 @item
-@code{:if-component-dep-fails} This attribute takes one of the values
-@code{:fail}, @code{:try-next}, @code{:ignore}, its default value is
-@code{:fail}.  The other values can be used for implementing
-conditional compilation based on implementation @code{*features*}, for
-the case where it is not necessary for all files in a module to be
+@code{:if-component-dep-fails}
+This attribute takes one of the values
+@code{:fail}, @code{:try-next}, @code{:ignore},
+its default value is @code{:fail}.
+The other values can be used for implementing conditional compilation
+based on implementation @code{*features*},
+for the case where it is not necessary for all files in a module to be
 compiled.
+@emph{FIXME: such conditional compilation has been reported
+to be broken in 2009.}
 
 @item
-@code{:serial} When this attribute is set, each subcomponent of this
-component is assumed to depend on all subcomponents before it in the
-list given to @code{:components}, i.e. all of them are loaded before
-a compile or load operation is performed on it.
+@code{:serial} When this attribute is set,
+each subcomponent of this component is assumed to depend on all subcomponents
+before it in the list given to @code{:components}, i.e.
+all of them are loaded before a compile or load operation is performed on it.
 
 @end itemize
 
-The default operation knows how to traverse a module, so most
-operations will not need to provide methods specialised on modules.
+The default operation knows how to traverse a module, so
+most operations will not need to provide methods specialised on modules.
 
 @code{module} may be subclassed to represent components such as
 foreign-language linked libraries or archive files.
@@ -894,11 +1553,11 @@
 @code{system} is a subclass of @code{module}.
 
 A system is a module with a few extra attributes for documentation
-purposes; these are given elsewhere.  @xref{The defsystem grammar}.
+purposes; these are given elsewhere.
+@xref{The defsystem grammar}.
 
-Users can create new classes for their systems: the default
-@code{defsystem} macro takes a @code{:classs} keyword
-argument.
+Users can create new classes for their systems:
+the default @code{defsystem} macro takes a @code{:class} keyword argument.
 @end deffn
 
 @node  Creating new component types,  , Pre-defined subclasses of component, Components
@@ -908,28 +1567,30 @@
 New component types are defined by subclassing one of the existing
 component classes and specializing methods on the new component class.
 
-@emph{FIXME: this should perhaps be explained more throughly, not only by
-example ...}
+@emph{FIXME: this should perhaps be explained more throughly,
+not only by example ...}
 
 As an example, suppose we have some implementation-dependent
-functionality that we want to isolate in one subdirectory per Lisp
-implementation our system supports.  We create a subclass of
+functionality that we want to isolate
+in one subdirectory per Lisp implementation our system supports.
+We create a subclass of
 @code{cl-source-file}:
 
 @lisp
 (defclass unportable-cl-source-file (cl-source-file)
-    ())
+  ())
 @end lisp
 
-A hypothetical function @code{system-dependent-dirname} gives us the
-name of the subdirectory.  All that's left is to define how to
-calculate the pathname of an @code{unportable-cl-source-file}.
+A hypothetical function @code{system-dependent-dirname}
+gives us the name of the subdirectory.
+All that's left is to define how to calculate the pathname
+of an @code{unportable-cl-source-file}.
 
 @lisp
 (defmethod component-pathname ((component unportable-cl-source-file))
   (let ((pathname (call-next-method))
         (name (string-downcase (system-dependent-dirname))))
-    (merge-pathnames
+    (merge-pathnames*
      (make-pathname :directory (list :relative name))
      pathname)))
 @end lisp
